﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "ABMPageTemplate"  '<-------------------------------------------------------- IMPORTANT
	' will hold the unique browsers window id
	Private ABMPageId As String = ""
	
	' your own variables
	Dim ToastId As Int
	
	Private tableNames As ABMTable, pagNames As ABMPagination
	Public const TABLE_STEP As Int = 5
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage
End Sub

#Region Always needed, no need to change anything at them
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
'	Log("Connected")		
	ws = WebSocket1	
	ABMPageId = ABM.GetPageID(page, Name,ws)
	
	Main.Server.Connected(Me, ws, page, ABMPageId)
	
'	Log(ABMPageId)
End Sub

Private Sub WebSocket_Disconnected
'	Log("Disconnected")
	Main.Server.Disconnected(ws)	
End Sub

Sub Page_ParseEvent(Params As Map)
	Main.Server.Page_ParseEvent(Me, page, ABMPageId, Params)
End Sub
#end region

' MUST be in here
public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(Main.MyTheme)

	' add page specific theme elements
	theme.AddInputTheme("inputTheme")
	theme.Input("inputTheme").BackColor = ABM.COLOR_GREEN
	theme.Input("inputTheme").BackColorIntensity = ABM.INTENSITY_LIGHTEN4
End Sub

' MUST be in here
public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & Main.Server.AppName & "/" & Name, False, Main.Server.SessionMaxInactiveIntervalSeconds, theme)
	page.ShowLoader=True
	page.PageHTMLName = "index.html"
	page.PageTitle = "Template"
	page.PageDescription = "Template"
	page.PageKeywords = ""
	page.PageSiteMapPriority = ""
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_YEARLY
		
	page.ShowConnectedIndicator = True
				
	' adding a navigation bar
	Main.BuildNavigationBar(page, "Title","../images/logo.png", "", "", "")
			
	' create the page grid, here we create 5 rows, each with one cell of 12 columns wide.
	page.AddRowsM(5,True,0,0, "").AddCells12MP(1,0,0,0,0,"")
	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	
	
	tableNames.Initialize(page, "tableNames", False, False, True, "")
End Sub

' MUST be in here
public Sub ConnectPage()
	' connecting the navigation bar
	Main.ConnectNavigationBar(page)

	' ----------- do your stuff like adding components to your grid, created in BuildPage
	Dim input As ABMInput
	input.Initialize(page, "input", ABM.INPUT_TEXT, "Your name", False, "inputTheme")
	page.Cell(1,1).AddComponent(input)
	
	Dim button As ABMButton
	button.InitializeFlat(page, "button", "", "", "Say Hello", "")
	page.Cell(2,1).AddComponent(button)
	' -----------
	
	Recalc_Pagination(0)
	page.Cell(4,1).AddComponent(tableNames)
	CreateTableFooterContainer("Names", tableNames,	pagNames)
	
	
	
	' refresh the page
	page.Refresh	
	' Tell the browser we finished loading
	page.FinishedLoading
	' restoring the navigation bar position
	page.RestoreNavigationBarPosition
End Sub

Sub button_Clicked(Target As String)
	' get the input compoent
	Dim input As ABMInput = page.Component("input")
	If input.Text = "" Then
		ToastId = ToastId + 1
		page.ShowToast(ToastId, "", "Please enter your name!", 5000, False)
		Return
	End If
	
	page.Msgbox("msgbox", "Hello " & input.Text & "!", "Welcome to ABM", "close", False, ABM.MSGBOX_POS_CENTER_CENTER, "")
End Sub

' result of clicking the close button on the messagebox
Sub Page_MsgboxResult(returnName As String, result As String)
	Select Case returnName
		Case "msgbox"
			Dim input As ABMInput = page.Component("input")
			input.Text = ""
			input.Refresh
	End Select
End Sub

' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	' saving the navigation bar position
	page.SaveNavigationBarPosition
	If Action = "LogOff" Then
		Main.LogOff(page)
		Return
	End If

	Main.Server.NavigateToPage(ws, ABMPageId, Value)
End Sub

Sub Recalc_Pagination(from As Int)
	Dim Total As Long = Refresh_tableNAMES(from)
	pagNames.Initialize(page, "pagNames", TABLE_STEP, True, True, "")
	pagNames.SetTotalNumberOfPages(Ceil(Total/TABLE_STEP))
End Sub

Sub CreateTableFooterContainer(tablename As String, table As ABMTable, pager As ABMPagination)
	Dim c As ABMContainer
	c.Initialize(page, "container_" & tablename, "")
	c.AddRowsV(1,True,ABM.VISIBILITY_ALL,"").AddCellsOSV(1,0,0,0,3,3,3,ABM.VISIBILITY_ALL,"").AddCellsOSV(1,0,0,0,7,7,7,ABM.VISIBILITY_ALL,"").AddCellsOSV(1,0,0,0,2,2,2,ABM.VISIBILITY_ALL,"")
	c.BuildGrid ' IMPORTANT!
	Dim L As ABMLabel
	L.Initialize(page, "tablename_" & tablename, tablename, ABM.SIZE_SMALL, False, "")
	c.Cell(1, 1).AddComponent(L)
	c.Cell(1, 2).AddComponent(pager)
	table.SetFooter(c, 12, "")
End Sub

Sub Refresh_tableNAMES(first As Int) As Long
	Dim SQLtable As String = "names"
	Dim WEBtable As ABMTable = tableNames
	WEBtable.SetHeaders(Array As String("id", "name", "source_name", "status", "rounds", "stamp", "comment", "actions"))
	Dim all As Long = DBM.SQLSelectSingleResult(DBM.GetSQL, "SELECT count(*) FROM " & SQLtable)
	Dim names As List = DBM.SQLSelect(DBM.GetSQL, "SELECT id, name, source_name, status, rounds, stamp, comment, '✎' FROM " & SQLtable & " LIMIT " & first & "," & TABLE_STEP)
	If names.Size > 0 Then
		WEBtable.Clear
		For i = 0 To names.Size - 1
			Dim m As Map = names.Get(i)
			Dim L As List = ReplaceNullinMap(m)
			WEBtable.AddRow(i, L)
		Next

	End If
	WEBtable.SetActiveRow(-1)
	WEBtable.Refresh
	Return all
End Sub

Sub ReplaceNullinMap(m As Map) As List
	Dim L As List
	L.Initialize
	For i = 0 To m.Size - 1
		Dim s As String = m.GetValueAt(i)
		If s.EqualsIgnoreCase("null") Then
			L.Add("")
		Else
			L.Add(s)
		End If
	Next
	Return L
End Sub

Sub pagNames_PageChanged(OldPage As Int, NewPage As Int)
	Log("pagNames = " & OldPage & " - " & NewPage)
	Dim total As Long = Refresh_tableNAMES((NewPage - 1) * TABLE_STEP)
	Dim Current_TotalNumberOfPages As Long = Ceil(total/TABLE_STEP)
	If Current_TotalNumberOfPages <> pagNames.GetTotalNumberOfPages Then
		Log("Current_TotalNumberOfPages = " & Current_TotalNumberOfPages)
		pagNames.SetTotalNumberOfPages(Current_TotalNumberOfPages)
		NewPage = 0
	End If
	pagNames.SetActivePage(NewPage)
	pagNames.Refresh
End Sub